local Addon, private = ...

setfenv(1, private)

-- Private methods
-- ============================================================================

local dlg
local textfield
dlg = function()
	local context = UI.CreateContext("")
	context:SetStrata("topmost")
	
	local self = UI.CreateFrame("Texture", "", context)
	self:SetTexture("Rift", "BagBar_BG_1a.png.dds")
	self:SetPoint("CENTER", UIParent, "CENTER")
	
	local msg = UI.CreateFrame("Text", "", self)
	msg:SetPoint("TOPCENTER", self, "TOPCENTER", 0, 30)
	msg:SetText("Copy the preselected text then hit [ESC] to close this popup.")
	
	textfield = UI.CreateFrame("RiftTextfield", "", self)
	textfield:SetPoint("TOPCENTER", msg, "BOTTOMCENTER")
	textfield:SetWidth(400)
	textfield:SetHeight(40)
	textfield:SetBackgroundColor(0, 0, 0, 0.5)
	textfield:EventAttach(Event.UI.Input.Key.Focus.Loss, function() dlg:FadeOut(false) end, "")
	
	dlg = self
	return self
end

-- Public methods
-- ============================================================================

function ShowCopyDialog(text)
	if(type(dlg) == "function") then
		dlg()
	end
	dlg:FadeIn()
	textfield:SetKeyFocus(true)
	textfield:SetText(text)
	textfield:SetSelection(0, #text)
end
